#pragma once

#include "api.h"
#include "proxyinterface.h"
#include <QObject>

#include <set>
#include <zmq.hpp>

class mitmproxyPlugin : public http::ProxyInterface
{
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "bigsnitch.api.HTTPProxyInterface/100" FILE "mitmproxy.json")
    Q_INTERFACES(http::ProxyInterface)
private:
    std::set<std::string> received;
    zmq::context_t context;
    zmq::socket_t *socket;
    std::set<std::string> accepted_flows;
    std::string path;
    bool is_connected = false;
    void connect();
    void reconnect();
public:
    //! called in a custom thread, may block.
    void process(std::string path) override;
    //! returns, whether the proxy is currently connected
    bool connected() override;
    //! disconnects the handle
    void disconnect() override;
    // options/settings
signals:
    //void finished();
    //void error(QString err);
    //void message(http::Flow flow);

};
